/*  Convert raw character file (ASCCI codes 0-9) into ASCII character	*/
/*  data using characters '0'-'9'.  Output is written as a "matrix"	*/
/*  with M rows of N digits each, no blanks.				*/
/*  Input should be in row-major order with no separators whatever.	*/
/*  Source file:  charmat.c						*/

#include <stdio.h>
#include <stdlib.h>

void main()
 { int M, N, i, j, c, err;  char fbuff[80];
   FILE *In, *Out;

 while ( 1 )		/* Indefinite loop to process files */
 { err = 0;		/* No errors yet */
   do			/* Get input file */
   { In = NULL;
     printf(" Input file (or q) > ");  scanf("%s", fbuff);
     if ( fbuff[0] == 'q' && fbuff[1] == 0 ) return;
     In = fopen(fbuff, "r");
     if ( ! In ) printf("Can't open file.\n");
   }
   while ( ! In );
   do			/* Get output file */
   { Out = NULL;
     printf("Output file (or q) > ");  scanf("%s", fbuff);
     if ( fbuff[0] == 'q' && fbuff[1] == 0 )
       { fclose(In);  return; }
     Out = fopen(fbuff, "w");
     if ( ! Out ) printf("Can't open file.\n");
   }
   while ( ! Out );
   printf("rows columns > ");  scanf("%d%d", &M, &N);	/* Matrix dim's */
   for ( i = 0;  i < M;  i++ )
    { for ( j = 0;  j < N;  j++ )
       { c = fgetc(In);
	 if ( c == EOF ) { printf("Error reading input.\n");  break; }
	 err = fputc(c + '0', Out);
	 if ( err == EOF) { printf("Error writing output.\n");  break; }
       }
      if ( c == EOF || err == EOF ) break;
      err = fputc('\n', Out);
      if ( err == EOF) { printf("Error writing output.\n");  break; }
    }
 }
 }
 
